using System;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using Castle.Windsor;

namespace FakeVader.Web {
    public class WindsorControllerFactory : DefaultControllerFactory {
        private readonly IWindsorContainer container;

        public WindsorControllerFactory(IWindsorContainer container) {
            this.container = container;
        }

        protected override IController GetControllerInstance(RequestContext context, Type controllerType)
        {
            if(controllerType == null) {
                throw new HttpException(404, "No such controller");
            }
            return (IController) container.Resolve(controllerType);
        }

        public override void ReleaseController(IController controller)
        {
            container.Release(controller);
        }
    }
}